<?php

/*
Plugin Name: MoceanSMS WooCommerce
Plugin URI:  https://dashboard.moceanapi.com
Description: MoceanSMS Order SMS Notification for WooCommerce
Version:     1.1.10
Author:      Micro Ocean Technologies
Author URI:  https://moceanapi.com
License:     GPLv3
License URI: http://www.gnu.org/licenses/gpl-3.0.html
Text Domain: moceansms-woocommerce
*/


if ( ! defined( 'WPINC' ) ) {
	die;
}

add_action( 'plugins_loaded', 'moceansms_woocommerce_init', PHP_INT_MAX );

function moceansms_woocommerce_init() {
	require_once ABSPATH . '/wp-admin/includes/plugin.php';
	require_once ABSPATH . '/wp-includes/pluggable.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/contracts/class-moceansms-register-interface.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-helper.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-frontend-scripts.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-hook.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-register.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-logger.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-notification.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-woocommerce-widget.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-moceansms-download-log.php';
	require_once plugin_dir_path( __FILE__ ) . 'includes/multivendor/class-moceansms-multivendor.php';
	require_once plugin_dir_path( __FILE__ ) . 'admin/class-moceansms-woocommerce-setting.php';
	require_once plugin_dir_path( __FILE__ ) . 'lib/class.settings-api.php';

	//create notification instance
	$moceansms_notification = new Moceansms_WooCommerce_Notification();

	//register hooks and settings
	$registerInstance = new Moceansms_WooCommerce_Register();
	$registerInstance->add( new Moceansms_WooCommerce_Hook( $moceansms_notification ) )
	                 ->add( new Moceansms_WooCommerce_Setting() )
	                 ->add( new Moceansms_WooCommerce_Widget() )
	                 ->add( new Moceansms_WooCommerce_Frontend_Scripts() )
	                 ->add( new Moceansms_Multivendor() )
	                 ->add( new Moceansms_Download_log() )
	                 ->load();
}

?>
